#include "launcher.h"

HINSTANCE hInst;
TCHAR g_szConnectAddress[128];

BOOL IsUnderWinMe(){
	OSVERSIONINFO osvi;
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&osvi);
	return (osvi.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS) && (osvi.dwMajorVersion <= 4) && (osvi.dwMinorVersion <= 90);
}

LPTSTR GetMyAddress(){
	static TCHAR h_name[256];
	struct hostent* host_ent;
	struct in_addr addr;

	gethostname(h_name, sizeof(h_name));

	host_ent = gethostbyname(h_name);

	if (host_ent->h_addr_list){
		int i = 0;
		while (host_ent->h_addr_list[i]){
			addr.S_un.S_addr = *(unsigned long*)host_ent->h_addr_list[i];
			if (htonl(addr.S_un.S_addr) >> 24 != 0x0A &&  //10.*.*.*
				htonl(addr.S_un.S_addr) >> 20 != 0xAC1 && //172.16-31.*.*
				htonl(addr.S_un.S_addr) >> 16 != 0xC0A8)  //192.168.*.*
				return inet_ntoa(addr);
			i++;
		}
		addr.S_un.S_addr = *(unsigned long*)host_ent->h_addr_list[0];
		wsprintf(h_name, "%s (local)", inet_ntoa(addr));
		return h_name;
	}
	return "(unknown)";
}

LPTSTR GetPuyoInstallPath(){
#define PUYO_REG "Software\\Sega\\PuyoF"

	HKEY hKey;
	DWORD dwcbData = MAX_PATH;
	static TCHAR s_szPuyoDir[MAX_PATH] = "";

	if (lstrlen(s_szPuyoDir) > 0)
		return s_szPuyoDir;

	if (RegOpenKeyEx(HKEY_CURRENT_USER, PUYO_REG, 0, 
		KEY_QUERY_VALUE, &hKey) != ERROR_SUCCESS){
		lstrcpy(s_szPuyoDir, "");
		return s_szPuyoDir;
	}
	
	if (RegQueryValueEx(hKey,"Install Path", NULL, NULL,
		(LPBYTE)s_szPuyoDir, &dwcbData) != ERROR_SUCCESS){
		lstrcpy(s_szPuyoDir, "");
	}

	RegCloseKey(hKey);

	return s_szPuyoDir;
}

HRESULT App_SHGetFolderPath(HWND hwnd, int csidl, HANDLE hToken, DWORD dwFlags, LPTSTR pszPath){
	typedef HRESULT WINAPI PFUNC(HWND, int, HANDLE, DWORD, LPTSTR);
	typedef PFUNC FAR *__SHGetFolderPathA;
	HINSTANCE hFunc;
	HRESULT r_Result;
	__SHGetFolderPathA _SHGetFolderPath;

	if ((hFunc = LoadLibrary("Shell32.dll")) == NULL){ //Cũ[h
		return (HRESULT)0xFFFFFFFFL;
	}
	_SHGetFolderPath = (__SHGetFolderPathA)GetProcAddress(hFunc, "SHGetFolderPathA"); //AhX̎擾
	if (_SHGetFolderPath == NULL){ //s̎
		FreeLibrary(hFunc);
		return (HRESULT)0xFFFFFFFFL;
	}

	r_Result = _SHGetFolderPath(hwnd, csidl, hToken, dwFlags, pszPath);
	FreeLibrary(hFunc); //[hCůJ	
	return r_Result;
}

LPTSTR GetPuyoDataPath(){
	static TCHAR s_szAppDir[MAX_PATH] = "";
	HRESULT hRes;

	if (lstrlen(s_szAppDir) > 0)
		return s_szAppDir;

	if (IsUnderWinMe()){
		lstrcpy(s_szAppDir, GetPuyoInstallPath());
		return s_szAppDir;
	}

	hRes = App_SHGetFolderPath(NULL, CSIDL_APPDATA, NULL, 0, s_szAppDir);
	if (SUCCEEDED(hRes))
		lstrcat(s_szAppDir, "\\Sega\\PuyoF\\");
	else{
		lstrcpy(s_szAppDir, GetPuyoInstallPath());
	}

	return s_szAppDir;

}

void RunPuyoF(LPTSTR szOption){
	TCHAR szPuyoPath[MAX_PATH];
	lstrcpy(szPuyoPath, GetPuyoInstallPath());
	lstrcat(szPuyoPath, "PuyoF.exe");

	if (ShellExecute(NULL, "open", szPuyoPath, szOption, GetPuyoInstallPath(), SW_SHOW) < (HINSTANCE)32)
		MessageBox(NULL, "NɎs܂", APP_TITLE, MB_OK | MB_ICONHAND);
}

void RunLobby(){
	TCHAR szLobbyPath[MAX_PATH];
	lstrcpy(szLobbyPath, GetPuyoInstallPath());
	lstrcat(szLobbyPath, "Lobby.exe");

	if (ShellExecute(NULL, "open", szLobbyPath, "PuyoF_ExecFromLauncher", GetPuyoInstallPath(), SW_SHOW) < (HINSTANCE)32)
		MessageBox(NULL, "NɎs܂", APP_TITLE, MB_OK | MB_ICONHAND);
}

void LoadAddrHistory(HWND hctrl){
	INT i;
	TCHAR szSec[16];
	PCHAR p;

	for (i = 0;i < 16;i++){
		wsprintf(szSec, "Addr%02d", i+1);
		p = GetAppSettingStr("Recent Connection", szSec, "");
		if (lstrlen(p) == 0)
			break;
		ComboBox_AddString(hctrl, p);
	}
}

void SpaceCut(LPTSTR psz){
	// Space R[h΋IɏI[
	PCHAR p;
	p = psz;
	while (*p){
		if (IsDBCSLeadByte(*p))
			p++;
		else if (*p == ' '){
			*p = 0;
			break;
		}
		p++;
	}
}

void SaveAddrHistory(HWND hctrl, LPCTSTR szNewCmd){
	INT i, j, len;
	TCHAR szSec[16];
	PCHAR pszData;

	if (lstrlen(szNewCmd) == 0)
		return;

	//܂VACeǉ
	SetAppSettingStr("Recent Connection", "Addr01", szNewCmd);
	j = 1;
	for (i = 0;j < 16;i++){
		len = ComboBox_GetLBTextLen(hctrl, i);
		if (len == CB_ERR)
			break;
		pszData = GlobalAlloc(GPTR, len + 1);
		ComboBox_GetLBText(hctrl, i, pszData);
		if (lstrcmpi(szNewCmd, pszData) == 0)
			continue;
		wsprintf(szSec, "Addr%02d", ++j);
		SetAppSettingStr("Recent Connection", szSec, pszData);
		GlobalFree(pszData);
	}
}

INT_PTR CALLBACK ConnectDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam){
	switch (uMsg){
	case WM_INITDIALOG:
		LoadAddrHistory(GetDlgItem(hDlg, IDC_CON_ADDR));
		SetFocus(GetDlgItem(hDlg, IDC_CON_ADDR));
		break;
	case WM_COMMAND:
		switch (LOWORD(wParam)){
		case IDOK:
			GetDlgItemText(hDlg, IDC_CON_ADDR, g_szConnectAddress, 128);
			SpaceCut(g_szConnectAddress);
			SaveAddrHistory(GetDlgItem(hDlg, IDC_CON_ADDR), g_szConnectAddress);
			EndDialog(hDlg, 1);
			break;
		case IDCANCEL:
			EndDialog(hDlg, 0);
			break;
		}
		break;
	case WM_CLOSE:
		EndDialog(hDlg, 0);
		break;
	default:
		return FALSE;
	}
	return TRUE;
}

INT_PTR CALLBACK MainDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam){
	static HICON hIcon;

	switch (uMsg){
	case WM_INITDIALOG:
		SetWindowText(hDlg, APP_TITLE);
		hIcon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICONMAIN));
		SendMessage(hDlg, WM_SETICON, ICON_SMALL, (LPARAM)hIcon);
		SetDlgItemText(hDlg, IDC_IPADDR, GetMyAddress());
		break;
	case WM_COMMAND:
		switch (LOWORD(wParam)){
		case IDCANCEL:
			EndDialog(hDlg, 0);
			break;
		case IDC_B_OFFLINE:
			RunPuyoF("SINGLE");
			EndDialog(hDlg, 1);
			break;
		case IDC_B_MATCHUP:
			RunPuyoF("S_MULTI1");
			EndDialog(hDlg, 1);
			break;
		case IDC_B_LOBBY:
			RunLobby();
			EndDialog(hDlg, 1);
			break;
		case IDC_B_HOST:
			RunPuyoF("D_HOST");
			EndDialog(hDlg, 1);
			break;
		case IDC_B_JOIN:
			if (DialogBox(hInst, MAKEINTRESOURCE(IDD_CONNECT), hDlg, ConnectDlgProc)){
				TCHAR szCmd[256];
				wsprintf(szCmd, "D_JOIN %s", g_szConnectAddress);
				RunPuyoF(szCmd);
				EndDialog(hDlg, 1);
			}
			break;
		case IDC_B_CONFIG:
			DoSetup(hDlg, 0);
			break;
		}
		break;
	case WM_DESTROY:
		DestroyIcon(hIcon);
		break;
	case WM_CLOSE:
		EndDialog(hDlg, 0);
		break;
	default:
		return FALSE;
	}
	return TRUE;
}


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow){
	WSADATA wd;
//	INITCOMMONCONTROLSEX icx;

	if (WSAStartup(MAKEWORD(1, 1), &wd)){
		MessageBox(NULL, "\Pbg̏Ɏs", APP_TITLE, MB_OK | MB_ICONHAND);
		return 0;
	}
	hInst = hInstance;

	InitCommonControls();
//	icx.dwSize = sizeof(INITCOMMONCONTROLSEX);
//	icx.dwICC = ICC_WIN95_CLASSES;
//	InitCommonControlsEx();

	DialogBox(hInstance, MAKEINTRESOURCE(IDD_MAINDLG), NULL, MainDlgProc);

	WSACleanup();
	return 1;
}
