#include "launcher.h"

#define PAGE_NUM 7

#define PS_PAGE_KEYASSIGN	0
#define PS_PAGE_MATCHUP		1
#define PS_PAGE_SHORTMSG	2
#define PS_PAGE_GRAPHICS	3
#define PS_PAGE_SOUND		4
#define PS_PAGE_BROWSE		5
#define PS_PAGE_ABOUT		6

#define KEY_BUTTON_UP		0
#define KEY_BUTTON_DOWN		1
#define KEY_BUTTON_LEFT		2
#define KEY_BUTTON_RIGHT	3
#define KEY_BUTTON_START	4
#define KEY_BUTTON_OK		5
#define KEY_BUTTON_CANCEL	6

extern HINSTANCE hInst;

COLORREF g_crMatchupColor = RGB(0x40, 0x40, 0x40);

UINT g_uKeybd1[7];
UINT g_uKeybd2[7];
UINT g_uJoyButton1[3];
UINT g_uJoyButton2[3];

CONST TCHAR *gcszButtonName[] = {"UP", "DOWN", "LEFT", "RIGHT", "PAUSE", "Rot. L", "Rot. R"};
CONST TCHAR *gcszPadName[] = {"PAUSE", "Rot. L", "Rot. R"};

CONST TCHAR *g_szMarkArray[] = {"-", "^", "\\", "@", "[", ";", ":", "]", ",", ".", "/", "B.Slash", "Up", "Down", "Left", "Right", "Space", "Enter", //18
	"NUM 0", "NUM 1", "NUM 2", "NUM 3", "NUM 4", "NUM 5", "NUM 6", "NUM 7", "NUM 8", "NUM 9",
	"NUM .", "NUM +", "NUM -", "NUM *", "NUM /", "NUM ENTER", 
	"A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", 
	"1", "2", "3", "4", "5", "6", "7", "8", "9", "0"};
CONST INT g_nMarkCode[] = {12, 144, 125, 145, 26, 39, 146, 27, 51, 52, 53, 43, 200, 208, 203, 205, 57, 28, //18
	82, 79, 80, 81, 75, 76, 77, 71, 72, 73, 
	83, 78, 74, 55, 181, 156, 
	30, 48, 46, 32, 18, 33, 34, 35, 23, 36, 37, 38, 50, 49, 24, 25, 16, 19, 31, 20, 22, 47, 17, 45, 21, 44, 
	2, 3, 4, 5, 6, 7, 8, 9, 10, 11}; //???

LPTSTR GetFileModDate(LPCTSTR lpszFile){
	WIN32_FIND_DATA wfd;
	FILETIME lfd;
	SYSTEMTIME st;
	HANDLE hFind;
	static TCHAR s_szFileDate[48];
	

	hFind = FindFirstFile(lpszFile, &wfd);

	if (hFind == INVALID_HANDLE_VALUE)
		lstrcpy(s_szFileDate, "----/--/--");
	else{
		FileTimeToLocalFileTime(&wfd.ftLastWriteTime, &lfd);
		FileTimeToSystemTime(&lfd, &st);

		FindClose(hFind);

		wsprintf(s_szFileDate, "%04d/%02d/%02d", st.wYear, st.wMonth, st.wDay);
	}
	return s_szFileDate;
}

INT GetKeyAssign(INT nId, INT nType, BOOL bGC){
	if (!bGC){
		if (nId == JOYSTICKID1){
			return g_uKeybd1[nType];
		} else if (nId == JOYSTICKID2){
			return g_uKeybd2[nType];
		} else 
			return -1;
	}else{
		if (nType < KEY_BUTTON_START || 
			nType > KEY_BUTTON_CANCEL)
			return -1;
		return (nId == JOYSTICKID1)?
			g_uJoyButton1[nType - KEY_BUTTON_START]:
			g_uJoyButton2[nType - KEY_BUTTON_START];
	}

	return -1;
}

INT SetKeyAssign(INT nId, INT nType, BOOL bGC, INT nValue){
	if (nValue == -1)
		return -1;
	if (!bGC){
		if (nId == JOYSTICKID1){
			g_uKeybd1[nType] = nValue;
		} else if (nId == JOYSTICKID2){
			g_uKeybd2[nType] = nValue;
		} else 
			return -1;
	}else{
		if (nType < KEY_BUTTON_START || 
			nType > KEY_BUTTON_CANCEL)
			return -1;
		if (nId == JOYSTICKID1)
			g_uJoyButton1[nType - KEY_BUTTON_START] = nValue;
		else
			g_uJoyButton2[nType - KEY_BUTTON_START] = nValue;
	}

	return nValue;
}

INT_PTR CALLBACK ChangeKeyDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam){

	switch (uMsg){
	case WM_INITDIALOG:{
		INT i, j = 0;
		// l̐ݒ

		if (HIWORD(lParam) == 0){
			for (i = 0;i < sizeof(g_szMarkArray) / sizeof(TCHAR*);i++){
				ComboBox_AddString(GetDlgItem(hDlg, IDC_CMB_KEYASSIGN), g_szMarkArray[i]);
				if (LOWORD(lParam) == g_nMarkCode[i]){
					j = i;
				}
			}
			ComboBox_SetCurSel(GetDlgItem(hDlg, IDC_CMB_KEYASSIGN), j);
		} else {
			// Joy Stickp^C}N
			ShowWindow(GetDlgItem(hDlg, IDC_CMB_KEYASSIGN), SW_HIDE);
			EnableWindow(GetDlgItem(hDlg, IDOK), FALSE);
			SetDlgItemText(hDlg, IDC_S_KEY_MSG, "VɊ蓖ĂQ[Rg[̃{^ĂB");
			SetTimer(hDlg, LOWORD(lParam), 200, NULL);
		}


		break;}
	case WM_TIMER:

		if (wParam == JOYSTICKID1){
			JOYINFOEX jix1;
			INT i;
			ZeroMemory(&jix1, sizeof(JOYINFOEX));
			jix1.dwSize = sizeof(JOYINFOEX);
			jix1.dwFlags = JOY_RETURNBUTTONS;

			if (joyGetPosEx(JOYSTICKID1, &jix1) == JOYERR_NOERROR){
				for (i = 0;i < sizeof(ULONG) * 8;i++){
					if (jix1.dwButtons & (JOY_BUTTON1 << i)){
						KillTimer(hDlg, JOYSTICKID1);
						EndDialog(hDlg, i);
						return TRUE;
					}
				}
				// đҋ@
			} else {
				KillTimer(hDlg, JOYSTICKID1);
				MessageBox(hDlg, "Q[Rg[̌oɃG[܂BڑуhComFĂB", APP_TITLE, MB_OK | MB_ICONHAND);
				EndDialog(hDlg, -1);
				return TRUE;
			}
		} else {
			JOYINFOEX jix2;
			INT i;
			ZeroMemory(&jix2, sizeof(JOYINFOEX));
			jix2.dwSize = sizeof(JOYINFOEX);
			jix2.dwFlags = JOY_RETURNBUTTONS;

			if (joyGetPosEx(JOYSTICKID2, &jix2) == JOYERR_NOERROR){
				for (i = 0;i < sizeof(ULONG) * 8;i++){
					if (jix2.dwButtons & (JOY_BUTTON1 << i)){
						KillTimer(hDlg, JOYSTICKID2);
						EndDialog(hDlg, i);
						return TRUE;
					}
				}
				// đҋ@
			} else {
				KillTimer(hDlg, JOYSTICKID2);
				MessageBox(hDlg, "Q[Rg[̌oɃG[܂BڑуhComFĂB", APP_TITLE, MB_OK | MB_ICONHAND);
				EndDialog(hDlg, -1);
				return TRUE;
			}
		}
		break;
	case WM_COMMAND:
		switch (LOWORD(wParam)){
		case IDOK:
			
			EndDialog(hDlg, 
				g_nMarkCode[ComboBox_GetCurSel(
				GetDlgItem(hDlg, IDC_CMB_KEYASSIGN))]); //R[hԍԂ
			break;
		case IDCANCEL:
			EndDialog(hDlg, -1);
			break;
		}
		break;
	case WM_CLOSE:
		EndDialog(hDlg, -1);
		break;
	default:
		return FALSE;
	}
	return TRUE;
}

INT ChangeKeyAssign(HWND hDlg, INT nId, INT nType, BOOL bUseGC){
	INT ret, nNowKeyAssign;

	nNowKeyAssign = GetKeyAssign(nId, nType, bUseGC);
	if (nNowKeyAssign == -1)
		nNowKeyAssign = 0; // {̓ftHgl̃[h
	ret = DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_GETKEY), hDlg, ChangeKeyDlgProc, MAKELPARAM(bUseGC?nId:nNowKeyAssign, bUseGC));
	if (ret == -1) // LZ
		return 0;

	// l̍XV
	SetKeyAssign(nId, nType, bUseGC, ret);

	return 1;
}

LPCTSTR GetAssignedKeyName(INT nId, INT nType, BOOL bUseGC){
	static TCHAR s_szKeyName[30] = "undef.";
	INT keycode, i;
	keycode = GetKeyAssign(nId, nType, bUseGC);


	if (bUseGC){
		if (nType <= KEY_BUTTON_RIGHT && nType >= KEY_BUTTON_UP)
			return "***";

		wsprintf(s_szKeyName, "KEY %d", keycode);
		return s_szKeyName;
	}

	if (keycode == -1)
		return "failed";

	for (i = 0;i < sizeof(g_szMarkArray) / sizeof(TCHAR*);i++){
		if (g_nMarkCode[i] == keycode){
			lstrcpy(s_szKeyName, g_szMarkArray[i]);
			break;
		}
	}
	return s_szKeyName;
}

void UpdateKeyAssign(HWND hDlg){
	BOOL bGC1Checked, bGC2Checked, bDA2Checked;
	bGC1Checked = IsDlgButtonChecked(hDlg, IDC_RAD_P1_GC);
	bGC2Checked = IsDlgButtonChecked(hDlg, IDC_RAD_P2_GC);
	bDA2Checked = IsDlgButtonChecked(hDlg, IDC_RAD_P2_DISABLED);

	SetDlgItemText(hDlg, IDC_B_P1_UP, GetAssignedKeyName(JOYSTICKID1, KEY_BUTTON_UP, bGC1Checked));
	SetDlgItemText(hDlg, IDC_B_P1_DOWN, GetAssignedKeyName(JOYSTICKID1, KEY_BUTTON_DOWN, bGC1Checked));
	SetDlgItemText(hDlg, IDC_B_P1_LEFT, GetAssignedKeyName(JOYSTICKID1, KEY_BUTTON_LEFT, bGC1Checked));
	SetDlgItemText(hDlg, IDC_B_P1_RIGHT, GetAssignedKeyName(JOYSTICKID1, KEY_BUTTON_RIGHT, bGC1Checked));
	SetDlgItemText(hDlg, IDC_B_P1_F1, GetAssignedKeyName(JOYSTICKID1, KEY_BUTTON_START, bGC1Checked));
	SetDlgItemText(hDlg, IDC_B_P1_F2, GetAssignedKeyName(JOYSTICKID1, KEY_BUTTON_OK, bGC1Checked));
	SetDlgItemText(hDlg, IDC_B_P1_F3, GetAssignedKeyName(JOYSTICKID1, KEY_BUTTON_CANCEL, bGC1Checked));

	SetDlgItemText(hDlg, IDC_B_P2_UP, GetAssignedKeyName(JOYSTICKID2, KEY_BUTTON_UP, bGC2Checked));
	SetDlgItemText(hDlg, IDC_B_P2_DOWN, GetAssignedKeyName(JOYSTICKID2, KEY_BUTTON_DOWN, bGC2Checked));
	SetDlgItemText(hDlg, IDC_B_P2_LEFT, GetAssignedKeyName(JOYSTICKID2, KEY_BUTTON_LEFT, bGC2Checked));
	SetDlgItemText(hDlg, IDC_B_P2_RIGHT, GetAssignedKeyName(JOYSTICKID2, KEY_BUTTON_RIGHT, bGC2Checked));
	SetDlgItemText(hDlg, IDC_B_P2_F1, GetAssignedKeyName(JOYSTICKID2, KEY_BUTTON_START, bGC2Checked));
	SetDlgItemText(hDlg, IDC_B_P2_F2, GetAssignedKeyName(JOYSTICKID2, KEY_BUTTON_OK, bGC2Checked));
	SetDlgItemText(hDlg, IDC_B_P2_F3, GetAssignedKeyName(JOYSTICKID2, KEY_BUTTON_CANCEL, bGC2Checked));

	EnableWindow(GetDlgItem(hDlg, IDC_B_P2_UP), !(bDA2Checked || bGC2Checked));
	EnableWindow(GetDlgItem(hDlg, IDC_B_P2_DOWN), !(bDA2Checked || bGC2Checked));
	EnableWindow(GetDlgItem(hDlg, IDC_B_P2_LEFT), !(bDA2Checked || bGC2Checked));
	EnableWindow(GetDlgItem(hDlg, IDC_B_P2_RIGHT), !(bDA2Checked || bGC2Checked));
	EnableWindow(GetDlgItem(hDlg, IDC_B_P2_F1), !bDA2Checked);
	EnableWindow(GetDlgItem(hDlg, IDC_B_P2_F2), !bDA2Checked);
	EnableWindow(GetDlgItem(hDlg, IDC_B_P2_F3), !bDA2Checked);
	EnableWindow(GetDlgItem(hDlg, IDC_S_P2_UP), !(bDA2Checked || bGC2Checked));
	EnableWindow(GetDlgItem(hDlg, IDC_S_P2_DOWN), !(bDA2Checked || bGC2Checked));
	EnableWindow(GetDlgItem(hDlg, IDC_S_P2_LEFT), !(bDA2Checked || bGC2Checked));
	EnableWindow(GetDlgItem(hDlg, IDC_S_P2_RIGHT), !(bDA2Checked || bGC2Checked));
	EnableWindow(GetDlgItem(hDlg, IDC_S_P2_F1), !bDA2Checked);
	EnableWindow(GetDlgItem(hDlg, IDC_S_P2_F2), !bDA2Checked);
	EnableWindow(GetDlgItem(hDlg, IDC_S_P2_F3), !bDA2Checked);

	EnableWindow(GetDlgItem(hDlg, IDC_B_P1_UP), !(bGC1Checked));
	EnableWindow(GetDlgItem(hDlg, IDC_B_P1_DOWN), !(bGC1Checked));
	EnableWindow(GetDlgItem(hDlg, IDC_B_P1_LEFT), !(bGC1Checked));
	EnableWindow(GetDlgItem(hDlg, IDC_B_P1_RIGHT), !(bGC1Checked));
	EnableWindow(GetDlgItem(hDlg, IDC_S_P1_UP), !(bGC1Checked));
	EnableWindow(GetDlgItem(hDlg, IDC_S_P1_DOWN), !(bGC1Checked));
	EnableWindow(GetDlgItem(hDlg, IDC_S_P1_LEFT), !(bGC1Checked));
	EnableWindow(GetDlgItem(hDlg, IDC_S_P1_RIGHT), !(bGC1Checked));
}

void ChangeMatchupColor(HWND hWndOwner){
	CHOOSECOLOR cc;
	COLORREF cr, c_ud[16];
	INT i;
	TCHAR szColorSec[32];

	for (i = 0;i < 16;i++){
		wsprintf(szColorSec, "Color%02d", i + 1);
		c_ud[i] = GetAppSettingInt("User-defined name color", szColorSec, RGB(0xFF, 0xFF, 0xFF));
	}

	ZeroMemory(&cc, sizeof(CHOOSECOLOR));
	cr = g_crMatchupColor;
	cc.lStructSize = sizeof(CHOOSECOLOR);
	cc.hwndOwner = hWndOwner;
	cc.Flags = CC_FULLOPEN | CC_ANYCOLOR | CC_RGBINIT;
	cc.rgbResult = cr;
	cc.hInstance = NULL;
	cc.lCustData = 0;
	cc.lpfnHook = NULL;
	cc.lpTemplateName = NULL;
	cc.lpCustColors = c_ud;

	if (ChooseColor(&cc) == 0){
		switch (CommDlgExtendedError()){
		case 0:
			return;
		default:
			MessageBox(hWndOwner, "FI_CAO{bNX̍쐬ɃG[܂B", APP_TITLE, MB_ICONHAND);
			return;
		}
	}

	for (i = 0;i < 16;i++){
		wsprintf(szColorSec, "Color%02d", i + 1);
		SetAppSettingIntX("User-defined name color", szColorSec, c_ud[i]);
	}

	g_crMatchupColor = cc.rgbResult;
}

BOOL ItemEditWndProc(HWND hWnd, UINT uMsg, WPARAM wParam,LPARAM lParam,int nId){
	switch (uMsg){
	case WM_INITDIALOG:
		if (nId == PS_PAGE_KEYASSIGN){
			JOYINFOEX jix;
			//GCڑ`FbN
			ZeroMemory(&jix, sizeof(JOYINFOEX));
			jix.dwSize = sizeof(JOYINFOEX);
			jix.dwFlags = JOY_RETURNBUTTONS;
			if (joyGetPosEx(JOYSTICKID1, &jix) != JOYERR_NOERROR ){
				EnableWindow(GetDlgItem(hWnd, IDC_RAD_P1_GC), FALSE);
			}
			//2
			ZeroMemory(&jix, sizeof(JOYINFOEX));
			jix.dwSize = sizeof(JOYINFOEX);
			jix.dwFlags = JOY_RETURNBUTTONS;
			if (joyGetPosEx(JOYSTICKID2, &jix) != JOYERR_NOERROR )
				EnableWindow(GetDlgItem(hWnd, IDC_RAD_P2_GC), FALSE);

			//L[
			g_uKeybd1[0] = GetPuyoSettingInt("PERIPHERAL", "PLAYER1 KEYBOARD UP", 200);
			g_uKeybd1[1] = GetPuyoSettingInt("PERIPHERAL", "PLAYER1 KEYBOARD DOWN", 208);
			g_uKeybd1[2] = GetPuyoSettingInt("PERIPHERAL", "PLAYER1 KEYBOARD LEFT", 203);
			g_uKeybd1[3] = GetPuyoSettingInt("PERIPHERAL", "PLAYER1 KEYBOARD RIGHT", 205);

			//{^
			g_uKeybd1[4] = GetPuyoSettingInt("PERIPHERAL", "PLAYER1 KEYBOARD FIRE1", 28);
			g_uKeybd1[5] = GetPuyoSettingInt("PERIPHERAL", "PLAYER1 KEYBOARD FIRE2", 44);
			g_uKeybd1[6] = GetPuyoSettingInt("PERIPHERAL", "PLAYER1 KEYBOARD FIRE3", 55);

			g_uJoyButton1[0] = GetPuyoSettingInt("PERIPHERAL", "PLAYER1 PAD FIRE1", 8);
			g_uJoyButton1[1] = GetPuyoSettingInt("PERIPHERAL", "PLAYER1 PAD FIRE2", 0);
			g_uJoyButton1[2] = GetPuyoSettingInt("PERIPHERAL", "PLAYER1 PAD FIRE3", 1);

			//L[
			g_uKeybd2[0] = GetPuyoSettingInt("PERIPHERAL", "PLAYER2 KEYBOARD UP", 22);
			g_uKeybd2[1] = GetPuyoSettingInt("PERIPHERAL", "PLAYER2 KEYBOARD DOWN", 36);
			g_uKeybd2[2] = GetPuyoSettingInt("PERIPHERAL", "PLAYER2 KEYBOARD LEFT", 35);
			g_uKeybd2[3] = GetPuyoSettingInt("PERIPHERAL", "PLAYER2 KEYBOARD RIGHT", 37);

			//{^
			g_uKeybd2[4] = GetPuyoSettingInt("PERIPHERAL", "PLAYER2 KEYBOARD FIRE1", 57);
			g_uKeybd2[5] = GetPuyoSettingInt("PERIPHERAL", "PLAYER2 KEYBOARD FIRE2", 24);
			g_uKeybd2[6] = GetPuyoSettingInt("PERIPHERAL", "PLAYER2 KEYBOARD FIRE3", 25);

			g_uJoyButton2[0] = GetPuyoSettingInt("PERIPHERAL", "PLAYER2 PAD FIRE1", 8);
			g_uJoyButton2[1] = GetPuyoSettingInt("PERIPHERAL", "PLAYER2 PAD FIRE2", 0);
			g_uJoyButton2[2] = GetPuyoSettingInt("PERIPHERAL", "PLAYER2 PAD FIRE3", 1);


			switch (GetPuyoSettingInt("PERIPHERAL", "PLAYER1 DEVICE", 0)){
			case 1:
				CheckDlgButton(hWnd, IDC_RAD_P1_GC, TRUE);
				break;
			default:
				CheckDlgButton(hWnd, IDC_RAD_P1_KB, TRUE);
				break;
			}
			switch (GetPuyoSettingInt("PERIPHERAL", "PLAYER2 DEVICE", 0)){
			case 1:
				CheckDlgButton(hWnd, IDC_RAD_P2_GC, TRUE);
				break;
			case 2:
				CheckDlgButton(hWnd, IDC_RAD_P2_DISABLED, TRUE);
				break;
			default:
				CheckDlgButton(hWnd, IDC_RAD_P2_KB, TRUE);
				break;
			}
			// L[R[h̍XV
			UpdateKeyAssign(hWnd);
		} else if (nId == PS_PAGE_SOUND){
			CheckDlgButton(hWnd, IDC_R_SOUND_Y, (GetPuyoSettingInt("SYSTEM", "SoundMode", 0) == 0));
			CheckDlgButton(hWnd, IDC_R_SOUND_N, !(GetPuyoSettingInt("SYSTEM", "SoundMode", 0) == 0));
		} else if (nId == PS_PAGE_MATCHUP){
			TCHAR szColorCode[24];
			ULONG ulMatchupColor = 0x00404040;

			SetDlgItemText(hWnd, IDC_ED_HANDLE_NAME, GetPuyoSettingStr("NETWORK", "Matchup_HandleName", ""));
			SetDlgItemText(hWnd, IDC_ED_LOGIN_ID, GetPuyoSettingStr("NETWORK", "Matchup_LoginName", ""));
			SetDlgItemText(hWnd, IDC_ED_PASSWD, GetPuyoSettingStr("NETWORK", "Matchup_Password", ""));

			CheckDlgButton(hWnd, IDC_CHK_AUTOSAVE_REPLAY, GetPuyoSettingInt("NETWORK", "ReplayAutoSave", 0));
			CheckDlgButton(hWnd, IDC_CHK_SAVELOG, GetPuyoSettingInt("NETWORK", "Log", 0));
			SetDlgItemInt(hWnd, IDC_ED_CHATLINES, GetPuyoSettingInt("NETWORK", "ChatLines", 4), FALSE);

			lstrcpy(szColorCode, GetPuyoSettingStr("NETWORK", "Matchup_Color", "0x00404040"));
			ulMatchupColor = strtoul(szColorCode, NULL, 16);

			if (ulMatchupColor == ULONG_MAX){
				ulMatchupColor = 0x00404040;
			}
			g_crMatchupColor = RGB(ulMatchupColor & 0x000000FF, 
				(ulMatchupColor & 0x0000FF00) >> 8,
				(ulMatchupColor & 0x00FF0000) >> 16);


		} else if (nId == PS_PAGE_SHORTMSG){
			INT i;
			TCHAR szKeyName[32];
			for (i = 0;i < 12;i++){
				wsprintf(szKeyName, "ShortCutMessage_F%02d", i + 1);
				SetDlgItemText(hWnd, IDC_ED_SM1 + i, GetPuyoSettingStr("NETWORK", szKeyName, ""));
			}
		} else if (nId == PS_PAGE_GRAPHICS){
			INT ws_x[] = {320, 320, 400, 480, 512, 640, 640, 800,
						1024, 1152, 1280, 1280, 1600, 1600, 1600};
			INT ws_y[] = {200, 240, 300, 360, 384, 400, 480, 600, 
						768, 864, 960, 1024, 900, 1024, 1200};
			INT i;
			TCHAR szResTmp[32];

			for (i = 0;i < sizeof(ws_x) / sizeof(INT);i++){
				wsprintf(szResTmp, "%4dx%4d", ws_x[i], ws_y[i]);
				ComboBox_AddString(GetDlgItem(hWnd, IDC_CMB_RESOLUTION), szResTmp);
			}
			ComboBox_SetCurSel(GetDlgItem(hWnd, IDC_CMB_RESOLUTION), GetPuyoSettingInt("SYSTEM", "Resolution", 6));

			CheckDlgButton(hWnd, (GetPuyoSettingInt("SYSTEM", "DrawMode", 1))?IDC_RAD_D3D:IDC_RAD_DDRAW, TRUE);
			CheckDlgButton(hWnd, (GetPuyoSettingInt("SYSTEM", "DrawBG", 1))?IDC_RAD_BG_Y:IDC_RAD_BG_N, TRUE);
			CheckDlgButton(hWnd, (GetPuyoSettingInt("SYSTEM", "FilterMode", 1))?IDC_RAD_D_SOFT:IDC_RAD_D_SHARP, TRUE);
			CheckDlgButton(hWnd, (GetPuyoSettingInt("SYSTEM", "ScreenMode", 0))?IDC_RAD_FULLSCREEN:IDC_RAD_WINDOW, TRUE);

			SetDlgItemInt(hWnd, IDC_ED_POS_X, GetPuyoSettingInt("SYSTEM", "WindowPosX", 0), TRUE);
			SetDlgItemInt(hWnd, IDC_ED_POS_Y, GetPuyoSettingInt("SYSTEM", "WindowPosY", 0), TRUE);

			if (IsDlgButtonChecked(hWnd, IDC_RAD_FULLSCREEN)){
				EnableWindow(GetDlgItem(hWnd, IDC_S_POS), FALSE);
				EnableWindow(GetDlgItem(hWnd, IDC_ED_POS_X), FALSE);
				EnableWindow(GetDlgItem(hWnd, IDC_ED_POS_Y), FALSE);
			}

			CheckDlgButton(hWnd, IDC_CHK_DISP_VER, GetPuyoSettingInt("SYSTEM", "DispVersion", 0));
			CheckDlgButton(hWnd, IDC_CHK_DISP_FPS, GetPuyoSettingInt("SYSTEM", "DispFPS", 0));

		}else if (nId == PS_PAGE_ABOUT){
			TCHAR szFileName[MAX_PATH], szFileInfo[MAX_PATH + 48];
			PCHAR pVer;

			//t@CXV擾
			wsprintf(szFileName, "%s%s", GetPuyoInstallPath(), "PuyoF.exe");
			wsprintf(szFileInfo, "PuyoF.exe (%s)", GetFileModDate(szFileName));
			SetDlgItemText(hWnd, IDC_S_PUYOF_DATE, szFileInfo);

			wsprintf(szFileName, "%s%s", GetPuyoInstallPath(), "Launcher.exe");
			wsprintf(szFileInfo, "Launcher.exe (%s)", GetFileModDate(szFileName));
			SetDlgItemText(hWnd, IDC_S_LAUNCH_DATE, szFileInfo);

			wsprintf(szFileName, "%s%s", GetPuyoInstallPath(), "Lobby.exe");
			wsprintf(szFileInfo, "Lobby.exe (%s)", GetFileModDate(szFileName));
			SetDlgItemText(hWnd, IDC_S_LOBBY_DATE, szFileInfo);

			//o[W擾i\[XȂ߁Ainiǂށj
			wsprintf(szFileName, "%s%s", GetPuyoInstallPath(), "Launcher.ini");
			GetPrivateProfileString("LauncherDlg", "WINDOWTITLE", "", szFileInfo, MAX_PATH + 48, szFileName);
			pVer = strstr(szFileInfo, "Ver");

			if (pVer == NULL){
				lstrcpy(szFileInfo, "擾Ɏs܂");
			}else
				lstrcpy(szFileInfo, pVer);

			SetDlgItemText(hWnd, IDC_S_PUYOF_VER, szFileInfo);

		}
		break;
	case WM_COMMAND:
		if (nId == PS_PAGE_SOUND){ //V[gʎq
			switch(LOWORD(wParam)){ //qRg[
			case IDC_B_DEFAULT: //ftHgݒ̃[h
				CheckDlgButton(hWnd, IDC_R_SOUND_Y, TRUE);
				CheckDlgButton(hWnd, IDC_R_SOUND_N, FALSE);
				break;
			}
		} else if (nId == PS_PAGE_SHORTMSG){
			switch(LOWORD(wParam)){ //qRg[
			case IDC_B_DEFAULT: //ftHgݒ̃[h
				SetDlgItemText(hWnd, IDC_ED_SM1, "͂悤܂");
				SetDlgItemText(hWnd, IDC_ED_SM2, "ɂ");
				SetDlgItemText(hWnd, IDC_ED_SM3, "΂");
				SetDlgItemText(hWnd, IDC_ED_SM4, "͂߂܂");
				SetDlgItemText(hWnd, IDC_ED_SM5, "낵肢܂");
				SetDlgItemText(hWnd, IDC_ED_SM6, "܁`");
				SetDlgItemText(hWnd, IDC_ED_SM7, "");
				SetDlgItemText(hWnd, IDC_ED_SM8, "`");
				SetDlgItemText(hWnd, IDC_ED_SM9, "΂񂫂`");
				SetDlgItemText(hWnd, IDC_ED_SM10, "肪Ƃ܂");
				SetDlgItemText(hWnd, IDC_ED_SM11, "ꂳ܂ł");
				SetDlgItemText(hWnd, IDC_ED_SM12, "܂ΐ킵܂傤");
				break;
			}
		} else if (nId == PS_PAGE_MATCHUP){
			switch(LOWORD(wParam)){ //qRg[
			case IDC_B_DEFAULT: //ftHgݒ̃[h
				g_crMatchupColor = RGB(0x40, 0x40, 0x40);
				SetDlgItemInt(hWnd, IDC_ED_CHATLINES, 3, FALSE);
				CheckDlgButton(hWnd, IDC_CHK_AUTOSAVE_REPLAY, FALSE);
				CheckDlgButton(hWnd, IDC_CHK_SAVELOG, FALSE);

				break;
			case IDC_B_USERREG:
				ShellExecute(hWnd, "open", "http://sega.jp/pc/soft/puyofever/win/user.html", NULL, NULL, SW_SHOWDEFAULT);
				break;
			case IDC_B_MTCOLOR:
				ChangeMatchupColor(hWnd);
				break;
			}
			break;
		} else if (nId == PS_PAGE_KEYASSIGN){


			switch (LOWORD(wParam)){
			case IDC_B_KA_DEFAULT:
				SetKeyAssign(JOYSTICKID1, KEY_BUTTON_UP, FALSE, 200);
				SetKeyAssign(JOYSTICKID1, KEY_BUTTON_DOWN, FALSE, 208);
				SetKeyAssign(JOYSTICKID1, KEY_BUTTON_LEFT, FALSE, 203);
				SetKeyAssign(JOYSTICKID1, KEY_BUTTON_RIGHT, FALSE, 205);
				SetKeyAssign(JOYSTICKID1, KEY_BUTTON_START, FALSE, 28);
				SetKeyAssign(JOYSTICKID1, KEY_BUTTON_OK, FALSE, 44);
				SetKeyAssign(JOYSTICKID1, KEY_BUTTON_CANCEL, FALSE, 45);

				
				CheckDlgButton(hWnd, IDC_RAD_P1_KB, TRUE);
				CheckDlgButton(hWnd, IDC_RAD_P1_GC, FALSE);
				CheckDlgButton(hWnd, IDC_RAD_P1_DISABLED, FALSE);
				CheckDlgButton(hWnd, IDC_RAD_P2_KB, FALSE);
				CheckDlgButton(hWnd, IDC_RAD_P2_GC, FALSE);
				CheckDlgButton(hWnd, IDC_RAD_P2_DISABLED, TRUE);

				SetKeyAssign(JOYSTICKID2, KEY_BUTTON_UP, FALSE, 22);
				SetKeyAssign(JOYSTICKID2, KEY_BUTTON_DOWN, FALSE, 36);
				SetKeyAssign(JOYSTICKID2, KEY_BUTTON_LEFT, FALSE, 35);
				SetKeyAssign(JOYSTICKID2, KEY_BUTTON_RIGHT, FALSE, 37);
				SetKeyAssign(JOYSTICKID2, KEY_BUTTON_START, FALSE, 57);
				SetKeyAssign(JOYSTICKID2, KEY_BUTTON_OK, FALSE, 24);
				SetKeyAssign(JOYSTICKID2, KEY_BUTTON_CANCEL, FALSE, 25);

				UpdateKeyAssign(hWnd);
				break;
			case IDC_RAD_P1_KB:
			case IDC_RAD_P1_GC:
			case IDC_RAD_P1_DISABLED:
			case IDC_RAD_P2_KB:
			case IDC_RAD_P2_GC:
			case IDC_RAD_P2_DISABLED:
				UpdateKeyAssign(hWnd);
				break;
			case IDC_B_P1_UP:
				if (ChangeKeyAssign(hWnd, JOYSTICKID1, KEY_BUTTON_UP, IsDlgButtonChecked(hWnd, IDC_RAD_P1_GC)))
					UpdateKeyAssign(hWnd);
				break;
			case IDC_B_P1_DOWN:
				if (ChangeKeyAssign(hWnd, JOYSTICKID1, KEY_BUTTON_DOWN, IsDlgButtonChecked(hWnd, IDC_RAD_P1_GC)))
					UpdateKeyAssign(hWnd);
				break;
			case IDC_B_P1_LEFT:
				if (ChangeKeyAssign(hWnd, JOYSTICKID1, KEY_BUTTON_LEFT, IsDlgButtonChecked(hWnd, IDC_RAD_P1_GC)))
					UpdateKeyAssign(hWnd);
				break;
			case IDC_B_P1_RIGHT:
				if (ChangeKeyAssign(hWnd, JOYSTICKID1, KEY_BUTTON_RIGHT, IsDlgButtonChecked(hWnd, IDC_RAD_P1_GC)))
					UpdateKeyAssign(hWnd);
				break;
			case IDC_B_P1_F1:
				if (ChangeKeyAssign(hWnd, JOYSTICKID1, KEY_BUTTON_START, IsDlgButtonChecked(hWnd, IDC_RAD_P1_GC)))
					UpdateKeyAssign(hWnd);
				break;
			case IDC_B_P1_F2:
				if (ChangeKeyAssign(hWnd, JOYSTICKID1, KEY_BUTTON_OK, IsDlgButtonChecked(hWnd, IDC_RAD_P1_GC)))
					UpdateKeyAssign(hWnd);
				break;
			case IDC_B_P1_F3:
				if (ChangeKeyAssign(hWnd, JOYSTICKID1, KEY_BUTTON_CANCEL, IsDlgButtonChecked(hWnd, IDC_RAD_P1_GC)))
					UpdateKeyAssign(hWnd);
				break;
			case IDC_B_P2_UP:
				if (ChangeKeyAssign(hWnd, JOYSTICKID2, KEY_BUTTON_UP, IsDlgButtonChecked(hWnd, IDC_RAD_P2_GC)))
					UpdateKeyAssign(hWnd);
				break;
			case IDC_B_P2_DOWN:
				if (ChangeKeyAssign(hWnd, JOYSTICKID2, KEY_BUTTON_DOWN, IsDlgButtonChecked(hWnd, IDC_RAD_P2_GC)))
					UpdateKeyAssign(hWnd);
				break;
			case IDC_B_P2_LEFT:
				if (ChangeKeyAssign(hWnd, JOYSTICKID2, KEY_BUTTON_LEFT, IsDlgButtonChecked(hWnd, IDC_RAD_P2_GC)))
					UpdateKeyAssign(hWnd);
				break;
			case IDC_B_P2_RIGHT:
				if (ChangeKeyAssign(hWnd, JOYSTICKID2, KEY_BUTTON_RIGHT, IsDlgButtonChecked(hWnd, IDC_RAD_P2_GC)))
					UpdateKeyAssign(hWnd);
				break;
			case IDC_B_P2_F1:
				if (ChangeKeyAssign(hWnd, JOYSTICKID2, KEY_BUTTON_START, IsDlgButtonChecked(hWnd, IDC_RAD_P2_GC)))
					UpdateKeyAssign(hWnd);
				break;
			case IDC_B_P2_F2:
				if (ChangeKeyAssign(hWnd, JOYSTICKID2, KEY_BUTTON_OK, IsDlgButtonChecked(hWnd, IDC_RAD_P2_GC)))
					UpdateKeyAssign(hWnd);
				break;
			case IDC_B_P2_F3:
				if (ChangeKeyAssign(hWnd, JOYSTICKID2, KEY_BUTTON_CANCEL, IsDlgButtonChecked(hWnd, IDC_RAD_P2_GC)))
					UpdateKeyAssign(hWnd);
				break;
			}
		} else if (nId == PS_PAGE_BROWSE){
			switch(LOWORD(wParam)){ //qRg[
			case IDC_B_BR_APPDATA:
				ShellExecute(hWnd, "open", GetPuyoDataPath(), NULL, NULL, SW_SHOWDEFAULT);
				break;
			case IDC_B_BR_INSTDIR:
				ShellExecute(hWnd, "open", GetPuyoInstallPath(), NULL, NULL, SW_SHOWDEFAULT);
				break;
			case IDC_B_BR_SEGA_NEW:
				ShellExecute(hWnd, "open", "http://sega.jp/pc/soft/puyofever/win/new.html", NULL, NULL, SW_SHOWDEFAULT);
				break;
			case IDC_B_BR_SEGA_TOP:
				ShellExecute(hWnd, "open", "http://sega.jp/pc/soft/puyofever/win/", NULL, NULL, SW_SHOWDEFAULT);
				break;
			}
		} else if (nId == PS_PAGE_GRAPHICS){
			switch (LOWORD(wParam)){
			case IDC_B_G_DEFAULT: //ftHg
				CheckDlgButton(hWnd, IDC_RAD_D3D, TRUE);
				CheckDlgButton(hWnd, IDC_RAD_DDRAW, FALSE);
				CheckDlgButton(hWnd, IDC_RAD_FULLSCREEN, TRUE);
				CheckDlgButton(hWnd, IDC_RAD_WINDOW, FALSE);
				EnableWindow(GetDlgItem(hWnd, IDC_S_POS), FALSE);
				EnableWindow(GetDlgItem(hWnd, IDC_ED_POS_X), FALSE);
				EnableWindow(GetDlgItem(hWnd, IDC_ED_POS_Y), FALSE);
				SetDlgItemInt(hWnd, IDC_ED_POS_X, 0, TRUE);
				SetDlgItemInt(hWnd, IDC_ED_POS_Y, 0, TRUE);
				CheckDlgButton(hWnd, IDC_RAD_BG_Y, TRUE);
				CheckDlgButton(hWnd, IDC_RAD_BG_N, FALSE);
				CheckDlgButton(hWnd, IDC_RAD_D_SHARP, FALSE);
				CheckDlgButton(hWnd, IDC_RAD_D_SOFT, TRUE);
				break;
			case IDC_RAD_D3D:
			case IDC_RAD_DDRAW:
				CheckDlgButton(hWnd, IDC_RAD_D3D, FALSE);
				CheckDlgButton(hWnd, IDC_RAD_DDRAW, FALSE);
				CheckDlgButton(hWnd, LOWORD(wParam), TRUE);
				break;
			case IDC_RAD_FULLSCREEN:
				CheckDlgButton(hWnd, IDC_RAD_FULLSCREEN, TRUE);
				CheckDlgButton(hWnd, IDC_RAD_WINDOW, FALSE);
				EnableWindow(GetDlgItem(hWnd, IDC_S_POS), FALSE);
				EnableWindow(GetDlgItem(hWnd, IDC_ED_POS_X), FALSE);
				EnableWindow(GetDlgItem(hWnd, IDC_ED_POS_Y), FALSE);
				break;
			case IDC_RAD_WINDOW:
				CheckDlgButton(hWnd, IDC_RAD_FULLSCREEN, FALSE);
				CheckDlgButton(hWnd, IDC_RAD_WINDOW, TRUE);
				EnableWindow(GetDlgItem(hWnd, IDC_S_POS), TRUE);
				EnableWindow(GetDlgItem(hWnd, IDC_ED_POS_X), TRUE);
				EnableWindow(GetDlgItem(hWnd, IDC_ED_POS_Y), TRUE);
				break;
			case IDC_RAD_BG_Y:
			case IDC_RAD_BG_N:
				CheckDlgButton(hWnd, IDC_RAD_BG_Y, FALSE);
				CheckDlgButton(hWnd, IDC_RAD_BG_N, FALSE);
				CheckDlgButton(hWnd, LOWORD(wParam), TRUE);
				break;
			case IDC_RAD_D_SHARP:
			case IDC_RAD_D_SOFT:
				CheckDlgButton(hWnd, IDC_RAD_D_SHARP, FALSE);
				CheckDlgButton(hWnd, IDC_RAD_D_SOFT, FALSE);
				CheckDlgButton(hWnd, LOWORD(wParam), TRUE);
				break;
			}
		}
		break;
	case WM_NOTIFY:
		switch (((NMHDR*)lParam)->code) {
		case PSN_APPLY: //XV{^
			if (nId == PS_PAGE_SOUND){ //TEh^u
				SetPuyoSettingInt("SYSTEM", "SoundMode", !IsDlgButtonChecked(hWnd, IDC_R_SOUND_Y));
			} else if (nId == PS_PAGE_KEYASSIGN){
				INT i, j, c;
				TCHAR szConfMsg[512] = "";
				TCHAR szTmp[512];

				c = 0;

				for (i = 0;i < 7;i++){
					for (j = i+1;j < 7;j++){
						if (g_uKeybd1[i] == g_uKeybd1[j]){
							c++;
							wsprintf(szTmp, "P%d %s - P%d %s (%s)\n", 1, gcszButtonName[j], 1, gcszButtonName[i], GetAssignedKeyName(JOYSTICKID1, j, FALSE));
							if (c < 5)
								lstrcat(szConfMsg, szTmp);
						}else if (g_uKeybd2[i] == g_uKeybd2[j]){
							c++;
							wsprintf(szTmp, "P%d %s - P%d %s (%s)\n", 2, gcszButtonName[j], 2, gcszButtonName[i], GetAssignedKeyName(JOYSTICKID2, i, FALSE));
							if (c < 5)
								lstrcat(szConfMsg, szTmp);
						}
					}
				}
				for (i = 0;i < 7;i++){
					for (j = 0;j < 7;j++){
						if (g_uKeybd2[i] == g_uKeybd1[j]){
							c++;
							wsprintf(szTmp, "P%d %s - P%d %s (%s)\n", 1, gcszButtonName[j], 2, gcszButtonName[i], GetAssignedKeyName(JOYSTICKID1, j, FALSE));
							if (c < 5)
								lstrcat(szConfMsg, szTmp);
						}
					}
				}

				if (c >= 5){
//					wsprintf(szTmp, "(ق%dŌ܂)", c - 5);
					lstrcat(szConfMsg, "...");
				}

				if (lstrlen(szConfMsg) > 0){
					wsprintf(szTmp, "ȉ̃L[ݒ肪dĂ܂B\n\n%s", szConfMsg);
					MessageBox(hWnd, szTmp, APP_TITLE, MB_ICONEXCLAMATION);
					SetWindowLong(hWnd, DWL_MSGRESULT, (LONG)-1);
					return TRUE;
				}

				if (IsDlgButtonChecked(hWnd, IDC_RAD_P1_GC)){
					for (i = 0;i < 3;i++){
						for (j = i+1;j < 3;j++){
							if (g_uJoyButton1[i] == g_uJoyButton1[j] && i != j){
								wsprintf(szConfMsg, "P%d %s - P%d %s (PAD %d)", 1, gcszPadName[i], 1, gcszPadName[j], g_uJoyButton1[i]);
								wsprintf(szTmp, "ȉ̃L[ݒ肪dĂ܂B\n\n%s", szConfMsg);
								MessageBox(hWnd, szTmp, APP_TITLE, MB_ICONEXCLAMATION);
								SetWindowLong(hWnd, DWL_MSGRESULT, (LONG)-1);
								return TRUE;
							}
						}
					}
				}
				if (IsDlgButtonChecked(hWnd, IDC_RAD_P2_GC)){
					for (i = 0;i < 3;i++){
						for (j = i+1;j < 3;j++){
							if (g_uJoyButton2[i] == g_uJoyButton2[j] && i != j){
								wsprintf(szConfMsg, "P%d %s - P%d %s (PAD %d)", 2, gcszPadName[i], 2, gcszPadName[j], g_uJoyButton2[i]);
								wsprintf(szTmp, "ȉ̃L[ݒ肪dĂ܂B\n\n%s", szConfMsg);
								MessageBox(hWnd, szTmp, APP_TITLE, MB_ICONEXCLAMATION);
								SetWindowLong(hWnd, DWL_MSGRESULT, (LONG)-1);
								return TRUE;
							}
						}
					}
				}

				SetPuyoSettingInt("PERIPHERAL", "PLAYER1 DEVICE", IsDlgButtonChecked(hWnd, IDC_RAD_P1_GC));
				SetPuyoSettingInt("PERIPHERAL", "PLAYER2 DEVICE", IsDlgButtonChecked(hWnd, IDC_RAD_P2_GC));

				if (IsDlgButtonChecked(hWnd, IDC_RAD_P2_DISABLED))
					SetPuyoSettingInt("PERIPHERAL", "PLAYER2 DEVICE", 2);


				//L[
				SetPuyoSettingInt("PERIPHERAL", "PLAYER1 KEYBOARD UP", g_uKeybd1[0]);
				SetPuyoSettingInt("PERIPHERAL", "PLAYER1 KEYBOARD DOWN", g_uKeybd1[1]);
				SetPuyoSettingInt("PERIPHERAL", "PLAYER1 KEYBOARD LEFT", g_uKeybd1[2]);
				SetPuyoSettingInt("PERIPHERAL", "PLAYER1 KEYBOARD RIGHT", g_uKeybd1[3]);
	
				//{^
				SetPuyoSettingInt("PERIPHERAL", "PLAYER1 KEYBOARD FIRE1", g_uKeybd1[4]);
				SetPuyoSettingInt("PERIPHERAL", "PLAYER1 KEYBOARD FIRE2", g_uKeybd1[5]);
				SetPuyoSettingInt("PERIPHERAL", "PLAYER1 KEYBOARD FIRE3", g_uKeybd1[6]);

				SetPuyoSettingInt("PERIPHERAL", "PLAYER1 PAD FIRE1", g_uJoyButton1[0]);
				SetPuyoSettingInt("PERIPHERAL", "PLAYER1 PAD FIRE2", g_uJoyButton1[1]);
				SetPuyoSettingInt("PERIPHERAL", "PLAYER1 PAD FIRE3", g_uJoyButton1[2]);

				//L[
				SetPuyoSettingInt("PERIPHERAL", "PLAYER2 KEYBOARD UP", g_uKeybd2[0]);
				SetPuyoSettingInt("PERIPHERAL", "PLAYER2 KEYBOARD DOWN", g_uKeybd2[1]);
				SetPuyoSettingInt("PERIPHERAL", "PLAYER2 KEYBOARD LEFT", g_uKeybd2[2]);
				SetPuyoSettingInt("PERIPHERAL", "PLAYER2 KEYBOARD RIGHT", g_uKeybd2[3]);
	
				//{^
				SetPuyoSettingInt("PERIPHERAL", "PLAYER2 KEYBOARD FIRE1", g_uKeybd2[4]);
				SetPuyoSettingInt("PERIPHERAL", "PLAYER2 KEYBOARD FIRE2", g_uKeybd2[5]);
				SetPuyoSettingInt("PERIPHERAL", "PLAYER2 KEYBOARD FIRE3", g_uKeybd2[6]);

				SetPuyoSettingInt("PERIPHERAL", "PLAYER2 PAD FIRE1", g_uJoyButton2[0]);
				SetPuyoSettingInt("PERIPHERAL", "PLAYER2 PAD FIRE2", g_uJoyButton2[1]);
				SetPuyoSettingInt("PERIPHERAL", "PLAYER2 PAD FIRE3", g_uJoyButton2[2]);

			} else if (nId == PS_PAGE_SHORTMSG){
				INT i;
				TCHAR szKeyName[32], szBuffer[256];
				for (i = 0;i < 12;i++){
					wsprintf(szKeyName, "ShortCutMessage_F%02d", i + 1);
					GetDlgItemText(hWnd, IDC_ED_SM1 + i, szBuffer, 256);
					SetPuyoSettingStr("NETWORK", szKeyName, szBuffer);
				}
			} else if (nId == PS_PAGE_GRAPHICS){
				SetPuyoSettingInt("SYSTEM", "Resolution", ComboBox_GetCurSel(GetDlgItem(hWnd, IDC_CMB_RESOLUTION)));

				SetPuyoSettingInt("SYSTEM", "ScreenMode", IsDlgButtonChecked(hWnd, IDC_RAD_FULLSCREEN));
				SetPuyoSettingInt("SYSTEM", "FilterMode", IsDlgButtonChecked(hWnd, IDC_RAD_D_SOFT));
				SetPuyoSettingInt("SYSTEM", "DrawMode", IsDlgButtonChecked(hWnd, IDC_RAD_D3D));
				SetPuyoSettingInt("SYSTEM", "DrawBG", IsDlgButtonChecked(hWnd, IDC_RAD_BG_Y));

				SetPuyoSettingInt("SYSTEM", "DispVersion", IsDlgButtonChecked(hWnd, IDC_CHK_DISP_VER));
				SetPuyoSettingInt("SYSTEM", "DispFPS", IsDlgButtonChecked(hWnd, IDC_CHK_DISP_FPS));

				SetPuyoSettingInt("SYSTEM", "WindowPosX", GetDlgItemInt(hWnd, IDC_ED_POS_X, NULL, TRUE));
				SetPuyoSettingInt("SYSTEM", "WindowPosY", GetDlgItemInt(hWnd, IDC_ED_POS_Y, NULL, TRUE));


			} else if (nId == PS_PAGE_MATCHUP){
				TCHAR szBuffer[256];
				INT n;

				GetDlgItemText(hWnd, IDC_ED_HANDLE_NAME, szBuffer, 256);
				SetPuyoSettingStr("NETWORK", "Matchup_HandleName", szBuffer);

				GetDlgItemText(hWnd, IDC_ED_LOGIN_ID, szBuffer, 256);
				SetPuyoSettingStr("NETWORK", "Matchup_LoginName", szBuffer);

				GetDlgItemText(hWnd, IDC_ED_PASSWD, szBuffer, 256);
				SetPuyoSettingStr("NETWORK", "Matchup_Password", szBuffer);

				wsprintf(szBuffer, "0x00%02X%02X%02X", GetBValue(g_crMatchupColor), GetGValue(g_crMatchupColor), GetRValue(g_crMatchupColor));
				SetPuyoSettingStr("NETWORK", "Matchup_Color", szBuffer);

				SetPuyoSettingInt("NETWORK", "ReplayAutoSave", IsDlgButtonChecked(hWnd, IDC_CHK_AUTOSAVE_REPLAY));
				SetPuyoSettingInt("NETWORK", "Log", IsDlgButtonChecked(hWnd, IDC_CHK_SAVELOG));

				n = GetDlgItemInt(hWnd, IDC_ED_CHATLINES, NULL, FALSE);
				if (n <= 1 || n > 30)
					n = 4;

				SetPuyoSettingInt("NETWORK", "ChatLines", n);
			}
			break;
		default:
			return FALSE;
		}
		break;
	case WM_CLOSE:
		DestroyWindow(hWnd);
		break;
	case WM_DESTROY:
		break;
	default:
		return FALSE;
	}
	return TRUE;
}

INT_PTR CALLBACK KeyAssignPageProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam){
	return ItemEditWndProc(hWnd, uMsg, wParam, lParam, PS_PAGE_KEYASSIGN);
}

INT_PTR CALLBACK MatchupPageProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam){
	return ItemEditWndProc(hWnd, uMsg, wParam, lParam, PS_PAGE_MATCHUP);
}

INT_PTR CALLBACK ShortMsgPageProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam){
	return ItemEditWndProc(hWnd, uMsg, wParam, lParam, PS_PAGE_SHORTMSG);
}

INT_PTR CALLBACK GraphicsPageProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam){
	return ItemEditWndProc(hWnd, uMsg, wParam, lParam, PS_PAGE_GRAPHICS);
}

INT_PTR CALLBACK SoundPageProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam){
	return ItemEditWndProc(hWnd, uMsg, wParam, lParam, PS_PAGE_SOUND);
}

INT_PTR CALLBACK BrowsePageProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam){
	return ItemEditWndProc(hWnd, uMsg, wParam, lParam, PS_PAGE_BROWSE);
}

INT_PTR CALLBACK AboutPageProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam){
	return ItemEditWndProc(hWnd, uMsg, wParam, lParam, PS_PAGE_ABOUT);
}

int CALLBACK PropSheetProc(HWND hDlg, UINT uMsg, LPARAM lParam){
	LONG lStyle;
	switch (uMsg) {
	case PSCB_PRECREATE :
		break;
	case PSCB_INITIALIZED:
		lStyle = GetWindowLong(hDlg, GWL_EXSTYLE);
		lStyle ^= WS_EX_CONTEXTHELP;
		SetWindowLong(hDlg, GWL_EXSTYLE, lStyle);
		break;
	}
	return 0;
}

BOOL DoSetup(HWND hWnd, UINT nStartPage) {
	PROPSHEETPAGE psp[PAGE_NUM];
	PROPSHEETHEADER psh;

	ZeroMemory(&psp, sizeof(PROPSHEETPAGE) * PAGE_NUM);

	psp[PS_PAGE_KEYASSIGN].dwSize = sizeof(PROPSHEETPAGE);
	psp[PS_PAGE_KEYASSIGN].dwFlags = 0;
	psp[PS_PAGE_KEYASSIGN].hInstance = hInst;
	psp[PS_PAGE_KEYASSIGN].pszTemplate = MAKEINTRESOURCE(IDD_KEYASSIGN);
	psp[PS_PAGE_KEYASSIGN].pfnDlgProc = KeyAssignPageProc;

	psp[PS_PAGE_MATCHUP].dwSize = sizeof(PROPSHEETPAGE);
	psp[PS_PAGE_MATCHUP].dwFlags = 0;
	psp[PS_PAGE_MATCHUP].hInstance = hInst;
	psp[PS_PAGE_MATCHUP].pszTemplate = MAKEINTRESOURCE(IDD_MATCHUP);
	psp[PS_PAGE_MATCHUP].pfnDlgProc = MatchupPageProc;

	psp[PS_PAGE_SHORTMSG].dwSize = sizeof(PROPSHEETPAGE);
	psp[PS_PAGE_SHORTMSG].dwFlags = 0;
	psp[PS_PAGE_SHORTMSG].hInstance = hInst;
	psp[PS_PAGE_SHORTMSG].pszTemplate = MAKEINTRESOURCE(IDD_SHORTMSG);
	psp[PS_PAGE_SHORTMSG].pfnDlgProc = ShortMsgPageProc;

	psp[PS_PAGE_GRAPHICS].dwSize = sizeof(PROPSHEETPAGE);
	psp[PS_PAGE_GRAPHICS].dwFlags = 0;
	psp[PS_PAGE_GRAPHICS].hInstance = hInst;
	psp[PS_PAGE_GRAPHICS].pszTemplate = MAKEINTRESOURCE(IDD_GRAPHICS);
	psp[PS_PAGE_GRAPHICS].pfnDlgProc = GraphicsPageProc;

	psp[PS_PAGE_SOUND].dwSize = sizeof(PROPSHEETPAGE);
	psp[PS_PAGE_SOUND].dwFlags = 0;
	psp[PS_PAGE_SOUND].hInstance = hInst;
	psp[PS_PAGE_SOUND].pszTemplate = MAKEINTRESOURCE(IDD_SOUND);
	psp[PS_PAGE_SOUND].pfnDlgProc = SoundPageProc;

	psp[PS_PAGE_BROWSE].dwSize = sizeof(PROPSHEETPAGE);
	psp[PS_PAGE_BROWSE].dwFlags = 0;
	psp[PS_PAGE_BROWSE].hInstance = hInst;
	psp[PS_PAGE_BROWSE].pszTemplate = MAKEINTRESOURCE(IDD_BROWSE);
	psp[PS_PAGE_BROWSE].pfnDlgProc = BrowsePageProc;

	psp[PS_PAGE_ABOUT].dwSize = sizeof(PROPSHEETPAGE);
	psp[PS_PAGE_ABOUT].dwFlags = 0;
	psp[PS_PAGE_ABOUT].hInstance = hInst;
	psp[PS_PAGE_ABOUT].pszTemplate = MAKEINTRESOURCE(IDD_ABOUT);
	psp[PS_PAGE_ABOUT].pfnDlgProc = AboutPageProc;

	ZeroMemory(&psh, sizeof(psh));
	psh.dwSize = sizeof(psh);
	psh.hwndParent = hWnd;
	psh.pszCaption = "ՂՂtB[o[ Win UConfigurator";
	psh.nPages = PAGE_NUM;
	psh.ppsp = psp;
	psh.nStartPage = nStartPage;
	psh.dwFlags = PSH_PROPSHEETPAGE | PSH_USECALLBACK | PSH_NOAPPLYNOW;
	psh.pfnCallback = PropSheetProc;

	if (PropertySheet(&psh) < 0){
		MessageBox(hWnd, "RtBOy[WJ܂", APP_TITLE, MB_ICONHAND | MB_OK);
		return FALSE;
	}
	return TRUE;
}

