#include <stdio.h>
#include <stdlib.h>
#include <winsock.h>

#include "ping.h"

int Ping();
int  WaitForEchoReply(SOCKET s);
unsigned short in_cksum(unsigned short *addr, int len);
int		SendEchoRequest(SOCKET, LPSOCKADDR_IN);
DWORD	RecvEchoReply(SOCKET, LPSOCKADDR_IN, unsigned char *);

int Ping()
{
	SOCKET	  rawSocket;
	LPHOSTENT lpHost;
	struct    sockaddr_in saDest;
	struct    sockaddr_in saSrc;
	DWORD	  dwTimeSent;
	DWORD	  dwElapsed;
	unsigned char    cTTL;
	int       nLoop;
	int       nRet;
	int       ping_ms;

	// \Pbg̍쐬
	rawSocket = socket(AF_INET, SOCK_RAW, IPPROTO_ICMP);
	if (rawSocket == SOCKET_ERROR) 
	{
		return -1;
	}
	
	// \PbgAhX̐ݒ
	saDest.sin_addr.s_addr = inet_addr("202.51.6.66");
	saDest.sin_family = AF_INET;
	saDest.sin_port = 0;

	// ICMPGR[v𑗐M
	SendEchoRequest(rawSocket, &saDest);

	// select()gpăf[^̎Mҋ@
	nRet = WaitForEchoReply(rawSocket);
	if (nRet == SOCKET_ERROR)
	{
		ping_ms = -2;
		goto ping_error;
	}
	if (!nRet)
	{
		ping_ms = -3;
		goto ping_error;
	}

	// M
	dwTimeSent = RecvEchoReply(rawSocket, &saSrc, &cTTL);

	// oߎԂvZ
	dwElapsed = GetTickCount() - dwTimeSent;
	ping_ms = dwElapsed;

	ping_error:

	nRet = closesocket(rawSocket);
	if (nRet == SOCKET_ERROR)
		return -4;

	return ping_ms;
}


// SendEchoRequest()
// GR[vwb_[ɏ
// ݒ肵AɑM
int SendEchoRequest(SOCKET s,LPSOCKADDR_IN lpstToAddr) 
{
	static ECHOREQUEST echoReq;
	static nId = 1;
	static nSeq = 1;
	int nRet;

	// GR[vɏݒ
	echoReq.icmpHdr.Type		= ICMP_ECHOREQ;
	echoReq.icmpHdr.Code		= 0;
	echoReq.icmpHdr.Checksum	= 0;
	echoReq.icmpHdr.ID			= nId++;
	echoReq.icmpHdr.Seq			= nSeq++;

	// Mf[^ݒ
	for (nRet = 0; nRet < REQ_DATASIZE; nRet++)
		echoReq.cData[nRet] = ' '+nRet;

	// M̃eBbNJEgۑ
	echoReq.dwTime				= GetTickCount();

	// pPbgɃf[^A`FbNTvZ
	echoReq.icmpHdr.Checksum = in_cksum((unsigned short *)&echoReq, sizeof(ECHOREQUEST));

	// GR[v𑗐M
	nRet = sendto(s,						// \Pbg
				 (LPSTR)&echoReq,			// obt@
				 sizeof(ECHOREQUEST),
				 0,							// tO
				 (LPSOCKADDR)lpstToAddr, // 
				 sizeof(SOCKADDR_IN));   // AhX̒

	return (nRet);
}


// RecvEchoReply()
// Mf[^MāA
// tB[hʂɉ͂
DWORD RecvEchoReply(SOCKET s, LPSOCKADDR_IN lpsaFrom, unsigned char *pTTL) 
{
	ECHOREPLY echoReply;
	int nRet;
	int nAddrLen = sizeof(struct sockaddr_in);

	// GR[M
	nRet = recvfrom(s,					// \Pbg
					(LPSTR)&echoReply,	// obt@
					sizeof(ECHOREPLY),	// obt@̃TCY
					0,					// tO
					(LPSOCKADDR)lpsaFrom,	// MAhX
					&nAddrLen);			// AhXւ̃|C^

	// ߂l`FbN

	// MIP TTLiԁjԂ
	*pTTL = echoReply.ipHdr.TTL;
	return(echoReply.echoRequest.dwTime);   		
}


// WaitForEchoReply()
// select()gpāAf[^
// ǂݎҋ@ǂ𔻕ʂ
int WaitForEchoReply(SOCKET s)
{
	struct timeval Timeout;
	fd_set readfds;

	readfds.fd_count = 1;
	readfds.fd_array[0] = s;
	Timeout.tv_sec = 5;
    Timeout.tv_usec = 0;

	return(select(1, &readfds, NULL, NULL, &Timeout));
}


//
// Mike Muuss' in_cksum() function
// and his comments from the original
// ping program
//
// * Author -
// *	Mike Muuss
// *	U. S. Army Ballistic Research Laboratory
// *	December, 1983

/*
 *			I N _ C K S U M
 *
 * Checksum routine for Internet Protocol family headers (C Version)
 *
 */
unsigned short in_cksum(unsigned short *addr, int len)
{
	register int nleft = len;
	register unsigned short *w = addr;
	register unsigned short answer;
	register int sum = 0;

	/*
	 *  Our algorithm is simple, using a 32 bit accumulator (sum),
	 *  we add sequential 16 bit words to it, and at the end, fold
	 *  back all the carry bits from the top 16 bits into the lower
	 *  16 bits.
	 */
	while( nleft > 1 )  {
		sum += *w++;
		nleft -= 2;
	}

	/* mop up an odd byte, if necessary */
	if( nleft == 1 ) {
		unsigned short	u = 0;

		*(unsigned char *)(&u) = *(unsigned char *)w ;
		sum += u;
	}

	/*
	 * add back carry outs from top 16 bits to low 16 bits
	 */
	sum = (sum >> 16) + (sum & 0xffff);	/* add hi 16 to low 16 */
	sum += (sum >> 16);			/* add carry */
	answer = ~sum;				/* truncate to 16 bits */
	return (answer);
}
