#include "launcher.h"

BOOL SetPuyoSettingStr(LPCTSTR szSection, LPCTSTR szKey, LPCTSTR szValue){
	TCHAR szConfigFile[MAX_PATH];
	lstrcpy(szConfigFile, GetPuyoDataPath());
	lstrcat(szConfigFile, "PuyoF.ini");
	return WritePrivateProfileString(szSection, szKey, szValue, szConfigFile); 
}

LPTSTR GetPuyoSettingStr(LPCTSTR szSection, LPCTSTR szKey, LPCTSTR szDefault){
	TCHAR szConfigFile[MAX_PATH];
	static TCHAR szReturn[256];
	lstrcpy(szConfigFile, GetPuyoDataPath());
	lstrcat(szConfigFile, "PuyoF.ini");
	GetPrivateProfileString(szSection, szKey, szDefault, szReturn, 256, szConfigFile);
	return szReturn;
}

INT GetPuyoSettingInt(LPCTSTR szSection, LPCTSTR szKey, INT nDefault){
	TCHAR szConfigFile[MAX_PATH];
	lstrcpy(szConfigFile, GetPuyoDataPath());
	lstrcat(szConfigFile, "PuyoF.ini");
	return GetPrivateProfileInt(szSection, szKey, nDefault, szConfigFile);
}

BOOL SetPuyoSettingInt(LPCTSTR szSection, LPCTSTR szKey, INT nValue){
	TCHAR szValStr[64];
	wsprintf(szValStr, "%d", nValue);
	return SetPuyoSettingStr(szSection, szKey, szValStr); 
}

INT GetAppSettingInt(LPCTSTR pszSection, LPCTSTR pszKey, INT nDefault){
	TCHAR szIniPath[MAX_PATH];
	PCHAR p;

	GetModuleFileName(NULL, szIniPath, MAX_PATH);
	CharUpper(szIniPath);
	p = strstr(szIniPath, ".EXE");
	lstrcpy(p, ".CFG");

	return GetPrivateProfileInt(pszSection, pszKey, nDefault, szIniPath);
}

LPTSTR GetAppSettingStr(LPCTSTR pszSection, LPCTSTR pszKey, LPCTSTR pszDefault){
	TCHAR szIniPath[MAX_PATH];
	static TCHAR szBuffer[256];
	PCHAR p;

	GetModuleFileName(NULL, szIniPath, MAX_PATH);
	CharUpper(szIniPath);
	p = strstr(szIniPath, ".EXE");
	lstrcpy(p, ".CFG");

	GetPrivateProfileString(pszSection, pszKey, pszDefault, szBuffer, 256, szIniPath);
	return szBuffer;
}

INT SetAppSettingStr(LPCTSTR pszSection, LPCTSTR pszKey, LPCTSTR pszData){
	TCHAR szIniPath[MAX_PATH];
	PCHAR p;

	GetModuleFileName(NULL, szIniPath, MAX_PATH);
	CharUpper(szIniPath);
	p = strstr(szIniPath, ".EXE");
	lstrcpy(p, ".CFG");

	return WritePrivateProfileString(pszSection, pszKey, pszData, szIniPath);
}

INT SetAppSettingIntX(LPCTSTR pszSection, LPCTSTR pszKey, INT nData){
	TCHAR szData[64];

	wsprintf(szData, "0x%06X", nData);

	return SetAppSettingStr(pszSection, pszKey, szData);
}

INT SetAppSettingInt(LPCTSTR pszSection, LPCTSTR pszKey, INT nData){
	TCHAR szData[64];

	wsprintf(szData, "%d", nData);

	return SetAppSettingStr(pszSection, pszKey, szData);
}
